"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getIsolatedQuery = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _lodash = _interopRequireDefault(require("lodash.clonedeep"));

var _traverse = _interopRequireDefault(require("traverse"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var getQuery = function getQuery(query) {
  if ((0, _typeof2.default)(query) === 'object' && query.definitions) {
    return query;
  } else if (typeof query === 'string') {
    return (0, _graphqlTag.default)(query);
  } else if ((0, _typeof2.default)(query) === 'object' && query.source) {
    return (0, _graphqlTag.default)(query.source);
  } else {
    throw new Error('Could not parse query: ' + query);
  }
};

var getIsolatedQuery = function getIsolatedQuery(querySource, fieldName, typeName) {
  var query = getQuery(querySource);
  console.log(query);
  var allQueriesWithFieldname = query.definitions[0].selectionSet.selections.filter(function (selection) {
    return selection.name && selection.name.kind === 'Name' && selection.name.value === fieldName;
  }).map(function (selection) {
    var name = selection.alias ? selection.alias.value : selection.name.value;
    var queryWithFieldname = (0, _lodash.default)(query);

    if (selection.selectionSet.selections.length && !selection.selectionSet.selections[0].arguments.length) {
      queryWithFieldname.definitions[0].variableDefinitions = [];
    }

    queryWithFieldname.definitions[0].selectionSet.selections = selection.selectionSet.selections;
    return {
      name: name,
      query: queryWithFieldname
    };
  });
  if (!allQueriesWithFieldname.length) return [];
  allQueriesWithFieldname.map(function (updatedQuery) {
    var usedFragments = new Set();
    (0, _traverse.default)(updatedQuery.query).forEach(function (x) {
      if (this.isLeaf && this.parent && this.parent.key === 'name') {
        if (this.parent.parent && this.parent.parent.node.kind === 'FragmentSpread') {
          usedFragments.add(this.parent.node.value);
        }
      }
    });
    var usedFragmentsArray = (0, _toConsumableArray2.default)(usedFragments);
    (0, _traverse.default)(updatedQuery.query).forEach(function (x) {
      if (this.isLeaf && this.parent && this.parent.key === 'name') {
        if (this.parent.parent && this.parent.parent.node.kind === 'NamedType') {
          if (typeof x === 'string' && x.indexOf("".concat(typeName, "_")) === 0) {
            this.update(x.substr(typeName.length + 1));
          }
        }

        if (this.parent.parent && this.parent.parent.node.kind === 'FragmentDefinition') {
          if (!usedFragmentsArray.includes(this.parent.node.value)) {
            this.parent.parent.delete();
          }
        }
      }
    });
  });
  return allQueriesWithFieldname;
};

exports.getIsolatedQuery = getIsolatedQuery;